package http;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.*;

public class RequestObj {
    public boolean post = false;
    private int errorLevel = 0;
    private String errorMsg = null;

    private String method = null;

    private String path = null;

    private String extension = null;

    private HashMap<String,String> getParamMap = null;

    private HashMap<String,String> postParamMap = null;

    private int keepAliveMillis = 0;
    public int getErrorLevel() {
        return errorLevel;
    }
    public String getErrorMsg() {
        return errorMsg;
    }

    private String[] getHeadaer(ArrayList<String> requestHeader) {
        int index = requestHeader.get(0).indexOf("\r\n");
        if(index < 0) {
            index = requestHeader.get(0).indexOf("\n");
        }
        String header = requestHeader.get(0).substring(0, index);
        return header.split(" ");
    }
    public void setRequestHeader(ArrayList<String> requestHeader) {
        post = false;
        if(requestHeader == null || requestHeader.size() == 0) {
            System.out.println("sȃNGXgł");
            errorLevel = 400;
            return;
        }
        try {
        	headLineCheck(requestHeader);
            // NGXgꂽt@C
            String[] head = getHeadaer(requestHeader);

            method = head[0];
            if(method.equals("POST")) {
                // POSTp[^擾
                int index =  requestHeader.get(0).lastIndexOf("\n") + 1;
                if(index > 0) {
                    postParamMap = splitGetParam(requestHeader.get(0).substring(index));
                }
                System.out.println("POST" + postParamMap);
                post = true;
            }
            String[] allPath = head[1].split("\\?");
            path = allPath[0];
            path = path.replaceAll("\\/", "\\\\");

            // GETp[^擾
            if(allPath.length > 1) {
                getParamMap = splitGetParam(allPath[1]);
                System.out.println("GET" + getParamMap);
            }

            // NGXg"\\"ŏIĂindex.htmlǉ
            if(path.lastIndexOf("\\") == (path.length() - 1)) {
                path += "index.html";
            }
            int index = path.lastIndexOf(".");
            if(index < 0) {
                extension = "";
            } else {
                extension = path.substring(index,path.length());
            }
            //System.out.println("\r\n\r\n");
            // NGXgɏꂽ200Ԃ
            errorLevel = 200;
        } catch(Exception e) {
            errorLevel = 400;
            e.printStackTrace();
        }
    }
    public String getPath() {
        return path;
    }
    public String getExtention() {
        return extension;
    }
    private HashMap<String,String> splitGetParam(String param) {
        HashMap<String,String> map = new HashMap<String,String>();
        String[] list = param.split("\\&");

        try{
            for(int i = 0;i < list.length;i++) {
                String[] str = list[i].split("\\=");
                String key = str[0];
                if(str.length < 2) {
                    map.put(key, "");
                } else {
                    String value = str[1];
                    map.put(key, value);
                }
            }
        } catch(Exception e) {
            e.printStackTrace();
        }
        return map;
    }
    public String getParam(String key) {
    	if(getParamMap == null) {
    		return null;
    	}
        return getParamMap.get(key);
    }
    public String postParam(String key) {
    	if(postParamMap == null) {
    		return null;
    	}
        return postParamMap.get(key);
    }
    public String postParamDec(String key) {
    	if(postParamMap == null) {
    		return null;
    	}
    	String ret = postParamMap.get(key);
    	if(ret != null) {
        	try {
				ret = URLDecoder.decode(ret, "utf-8");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
				ret = null;
			}
    	}
        return ret;
    }
    private void headLineCheck(ArrayList<String> requestHeader) {
    	for(String requestHead:requestHeader) {
    		String[] headers = requestHead.split("\n");
    		for(String line: headers) {
    			String[] str = line.split(":");
    			if(str != null && str.length == 2) {
    				str[0] = str[0].toLowerCase();
    				if("keep-alive".equals(str[0])) {
    					str[1] =str[1].trim();
    					int time = Integer.parseInt(str[1]);
    					keepAliveMillis = time;
    				}
    			}
    		}
    	}
    }
}
